/**********************************************************************************************
@author     : Aditi Singh
@date       : 
@description: This controller is for managing assignments of employees through alignment workflow
              as well as assignment/unassignment of employees through roster workflow.
Revison(s)  : 
**********************************************************************************************/

public with sharing class ManageAssignments{
    public static String namespace {get{ return SalesIQGlobalConstants.NAME_SPACE;} set;}
    public String teamInstanceVal{get;set;} // team instance id of selected position
    public String TerrId{get;set;} //territory id captured from URL
    public String team{get;set;} //team Instance value in breadcrumb
    public String empChosen{get;set;} //employee chosen for Assignment from employees universe list
    String soql;// string to maintain dynamic soql query for employees list
    public list<Position_Employee__c>curAssignments{get;set;}// List of current assignments to selected position
    Position_Employee__c assignEmpToPos{get;set;}
    public String posType{get;set;}// position type of selected position
    
    Position__c selectedURLPosition{get;set;}// Position of id captured from URL 
    
    public list<wrapperEmployeeAssignment>empAssignmentList{get;set;}
    public String selectedEmployeeName{get;set;} // selected employee name to be displayed on employee assignment details section
    CR_Employee_Assignment__c workbenchChangeRequest;//change Request for id captured from URL
    public String changeRequest{get;set;}//change Request id captured from URL
    Set<Id>setOfEmployees;//set of employees assigned to some Position
    public String selectedRadio{get;set;}//id of employee selected from employee universe list
    list<Position_Employee__c> posEmp;
    public list<wrapperCurrentAssignments>wrapperListCurAssign{get;set;}
    public String deleteId{get;set;}    
    public list<Employee_Status__c> currentEmpStat{get;set;}
    list<Employee_Status__c> listEmpStat;
    public Date todayDate{get;set;}
    public Date dateNewInstance{get;set;}
    
    public Integer selectedID {get;set;}
    public boolean assignLock {get;set;}
    public boolean isLock{get;set;}
    public boolean isSaveAssignSuccess{get;set;}
    set<Id> territoryIds = new set<Id>();
    public boolean showCRMsg {get;set;}
    public String crname {get;set;}
    public String teamType;
    public list<string> selectedTerritoryHierarchy {get;set;}
    public string posLevel {get;set;}
    public Position__c selectedPos;
    public string selectedPositionName {get;set;}
    public ID selectedPosId{get;set;}
    public boolean showSavePopup{get;set;}

    public Boolean isPageLoadOK {get; set;}
    public Date teamInstanceEffectiveStartDate {get;set;}
    public Date teamInstanceEffectiveEndDate {get;set;}
    public boolean isFutureTeamInstance {get;set;}
    public string teamID {get;set;}

    public String severity {get;set;}
    public String message {get;set;}
    public boolean showMessage {get;set;}
    public String notificationTimer{get;set;}

    /*********************************************Constructor*********************************************/
    public ManageAssignments(){
        try{
            isPageLoadOK = true;
            showSavePopup = false;
            crname = '';
            isFutureTeamInstance = false;
            showMessage = false;
            message = '';
            if(Alignment_Global_Settings__c.getValues('notificationTimeOut') != null)
                notificationTimer = Alignment_Global_Settings__c.getValues('notificationTimeOut').Tree_Hierarchy_Sort_Field__c;
            else
                notificationTimer = '10000';


            teamID = ApexPages.currentPage().getParameters().get('teamID');
            TerrId = ApexPages.currentPage().getParameters().get('territory');
            territoryIds.add(TerrId);
            changeRequest = ApexPages.currentPage().getParameters().get('eventId');
            teamInstanceVal = ApexPages.currentPage().getParameters().get('teamInstanceID');
            todayDate = date.today();
            
            dateNewInstance = Date.newInstance(2099, 12, 31);
            workbenchChangeRequest = new CR_Employee_Assignment__c();
            wrapperListCurAssign = new list<wrapperCurrentAssignments>();
            soql = '';
            isLock = false;
            assignLock = isLock;
            isSaveAssignSuccess = false;
            assignEmpToPos = new Position_Employee__c();
            empAssignmentList = new list<wrapperEmployeeAssignment>();
            posEmp = new list<Position_Employee__c>();
            listEmpStat = new list<Employee_Status__c>();
            empChosen = '';
            String selectedPosition = '';
            if(TerrId!=null){
                if ((SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) && (SecurityUtil.checkRead(Team__c.SObjectType, TEAM_READ_FIELD, false)) && (SecurityUtil.checkRead(Team_Instance__c.SObjectType, new list<string>{'IC_EffstartDate__c', 'IC_EffendDate__c'}, false))){
                    selectedURLPosition = [select id, Name, Parent_Position__r.Name, Client_Position_Code__c, Assignment_status__c, Position_Type__c, Team_iD__r.Type__c, 
                                            Effective_Start_Date__c, Effective_End_Date__c, Team_iD__r.Name, Team_Instance__r.IC_EffstartDate__c, Team_Instance__r.IC_EffendDate__c from Position__c 
                                            where id =: terrId limit 1];
                    
                }
                                        
                if(selectedURLPosition!=null){
                    //District = String.escapeSingleQuotes(selectedURLPosition.parent_position__r.name);
                    //Territory = String.escapeSingleQuotes(selectedURLPosition.name);
                    posType = String.escapeSingleQuotes(selectedURLPosition.position_type__c);
                    team  = selectedURLPosition.Team_iD__r.Name;
                    teamType = selectedURLPosition.Team_iD__r.Type__c;
                    selectedPositionName = selectedURLPosition.name;
                    selectedPosId = selectedURLPosition.id;
                    teamInstanceEffectiveStartDate = selectedURLPosition.Team_Instance__r.IC_EffstartDate__c;
                    teamInstanceEffectiveEndDate = selectedURLPosition.Team_Instance__r.IC_EffendDate__c;

                    system.debug('--teamInstanceEffectiveStartDate ' + teamInstanceEffectiveStartDate);

                    if(system.today() < teamInstanceEffectiveStartDate)
                        isFutureTeamInstance = true;
                }
            }
            
            runSearch();
    
    
            currentAssignments();
            list<User_Access_Permission__c> accessPermissions = SalesIqUtility.getUserAccessPermistion(UserInfo.getUserId(), teamInstanceVal) ;
            if(!accessPermissions.isEmpty()) {
              selectedPosition = SalesIqUtility.getUserAccessPermistion(UserInfo.getUserId(), teamInstanceVal)[0].Position__c;
            } else {
              //ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.ERROR, System.Label.No_UAP_Assigned)); 
              //notification-toast
              setMessageParams( System.Label.Message_Theme_Error,System.Label.No_UAP_Assigned);
            }
        
            list<Position__c> allAccessiblePositions = SalesIQUtility.getPositionbyRootPositionId(selectedPosition, TeamType);
            
            /*     
            for(Position__c pos : allAccessiblePositions){
                allPositionMap.put(pos.Id,pos);
            }*/
            
            getBreadcrumHierarchyList(allAccessiblePositions);
            list<CR_Employee_Assignment__c> listPosEmpAssgn;
            
            if ((SecurityUtil.checkRead(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_FIELD, false)) && 
                (SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELD, false))){
                    listPosEmpAssgn = [select id, name, Change_Request_ID__r.status__c, Position_ID__c, Change_Request_ID__r.name from CR_Employee_Assignment__c where Position_ID__c=: terrID and Change_Request_ID__r.status__c = 'Pending' and Change_Request_ID__r.Request_Type_Change__c = 'Employee Assignment'];
            }
            
            if(listPosEmpAssgn.size() > 0){
                isLock = true; 
                assignLock = true;
                //ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.INFO, string.format(System.Label.PositionEditPendingRequestPrompt,new list<string>{listPosEmpAssgn[0].Change_Request_ID__r.name}));
                //ApexPages.addMessage(myMsg);

                //notification-toast
                setMessageParams( System.Label.Message_Theme_Success, string.format(System.Label.PositionEditPendingRequestPrompt,new list<string>{listPosEmpAssgn[0].Change_Request_ID__r.name}) );
            }
        }catch(exception ex){
            SalesIQLogger.logMessage(ex);
            isPageLoadOK = false;
        }    
    }
    
    // this method will check object level and field level permissions on all the objects used in manageAssignment page 
    // this method will be called on page load automatically.    
    
     public void actionInit() {
        // check the security util for getters methods and action fucntion called on page load
        try {
            
            list<string> POSITION_EMPLOYEE_READ_FIELD = new list<string>{'Effective_End_Date__c','Effective_Start_Date__c','Assignment_Type__c','Reason_Code__c','Employee__c'};
            list<String> CHANGE_REQUEST_READ_FIELD = new list<String>{'Status__c','source_position__c','destination_position__c','RecordTypeID__c','Execution_Date__c','Request_Type_Change__c','Team_Instance_ID__c','RecordtypeId__c'};
            list<String> POSITION_READ_FIELD = new list<String>{'Change_Status_del__c','Effective_End_Date__c','Effective_Start_Date__c','Position_Type__c'};
            list<String> EMPLOYEE_READ_FIELD = new list<String>{'Employee_ID__c','Manager__c','Current_Territory__c','Change_status__c','HR_Status__c','Field_Status__c','Employee_Type__c'};

            //SecurityUtil.checkInsert(Change_Request__c.SObjectType,CHANGE_REQUEST_READ_FIELD,false);
            SecurityUtil.checkInsert(Position_Employee__c.SObjectType,POSITION_EMPLOYEE_READ_FIELD,false);
            SecurityUtil.checkRead(Position__c.SObjectType,POSITION_READ_FIELD,false);
            SecurityUtil.checkRead(Employee__c.SObjectType,EMPLOYEE_READ_FIELD,false);
            
            isPageLoadOK = true;            
        }catch(exception ex){
            SalesIQLogger.logMessage(ex);
            isPageLoadOK = false;
        }

    }
    
    public void showPopup(){
        showSavePopup = true;
    }
    
    public void closeSavePopup(){
        showSavePopup = false;
    }
 
    // method to get breadcrum Hierarchy
    public void getBreadcrumHierarchyList(list<Position__c> allAccessiblePositions){
        
        try{
            //refresh data for breadcrumb
            selectedTerritoryHierarchy = new list<string>();
            Map<Id, Position__c> allPositionMap = new Map<Id, Position__c>();
    
            for(Position__c pos : allAccessiblePositions){
                allPositionMap.put(pos.Id,pos);
            }
                
            selectedPos = allPositionMap.get(TerrId);
           
            posLevel = selectedPos.Hierarchy_Level__c;
            
            //selectedTerritoryHierarchy.add('Employee Assignment');
            selectedTerritoryHierarchy.add(team);
            
            Position__c level2Pos;
            Position__c level3Pos;
            Position__c level4Pos;
            Position__c level5Pos;
            
            if(allPositionMap.containsKey(selectedPos.Parent_Position__c)){
                level2Pos = allPositionMap.get(selectedPos.Parent_Position__c);
            }
        
            if(level2Pos != null && allPositionMap.containsKey(level2Pos.Parent_Position__c)){
                level3Pos = allPositionMap.get(level2Pos.Parent_Position__c);    
            }
       
            if(level3Pos != null && allPositionMap.containsKey(level3Pos.Parent_Position__c)){
                level4Pos = allPositionMap.get(level3Pos.Parent_Position__c);    
            }
       
            if(level4Pos != null && allPositionMap.containsKey(level4Pos.Parent_Position__c)){
                level5Pos = allPositionMap.get(level4Pos.Parent_Position__c);    
            }
            
            if(level5Pos != null)
                selectedTerritoryHierarchy.add(level5Pos.Name);
            if(level4Pos != null)
                selectedTerritoryHierarchy.add(level4Pos.Name);
            if(level3Pos != null)
                selectedTerritoryHierarchy.add(level3Pos.Name);
            if(level2Pos != null)
                selectedTerritoryHierarchy.add(level2Pos.Name);
            selectedTerritoryHierarchy.add(selectedPos.Client_Territory_Name__c);
        }catch(exception ex){
            SalesIQLogger.logMessage(ex);
        }
    }

    @testVisible
    private void runSearch(){
   
        list<Position_Employee__c> posEmpList = new list<Position_Employee__c>();//List of Positions with employees assigned
        list<EmployeesWrapper> empWrapperList = new list<EmployeesWrapper>();
        string empid = Apexpages.currentPage().getParameters().get('empid');
        //Fetch all Assigned employees from Position Employee
        string posEmpSoql = '';//soql query from position employee
        posEmpSoql = 'Select p.Position__r.Client_Territory_Name__c, p.Position__r.Client_Territory_Code__c, p.employee__r.change_status__c,p.employee__r.HR_Status__c, Assignment_Type__c, p.Position__r.Client_Position_Code__c, p.Position__r.Name, p.Position__c, p.Position__r.Position_Type__c, p.Position__r.Effective_End_Date__c, p.Position__r.Effective_Start_Date__c,p.Effective_End_Date__c, p.Effective_Start_Date__c, p.Employee__r.Employee_ID__c, p.Employee__r.Name, p.Employee__r.Id, p.Employee__c,p.Employee__r.Employee_Type__c,p.Employee__r.Job_Title__c From Position_Employee__c p ';
    
        if (empid != null && !empid.equals('')){
            String val1 ='\'%' + String.escapeSingleQuotes(empid) + '%\'';
            posEmpSoql += ' where (Employee__r.Name LIKE '+val1+' or Employee__r.Employee_id__c LIKE '+val1+')';
        }
        
        String otherqueryforuniqueEmp = '';//string for query fetching unique employees
        otherqueryforuniqueEmp = posEmpSoql;
        
        if ((SecurityUtil.checkRead(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_READ_FIELD, false)) && 
            (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) &&
            (SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
        {
            posEmpList = Database.query(posEmpSoql);
        }
        
        
        set<String>uniqueEmpIdSet = new Set<String>();
        set<string> assignedEmpIds = new set<string>();
        for(Position_Employee__c pe : posEmpList){
            if(pe.Assignment_Type__c == 'Primary' && pe.Effective_End_Date__c > date.today()){
                assignedEmpIds.add(pe.Employee__c);
                uniqueEmpIdSet.add(pe.employee__r.employee_id__c);  
            }
            
        }
        
        Set<Position_Employee__c> finalSet = new Set<Position_Employee__c>();
        List<Position_Employee__c> finalList = new list<Position_Employee__c>();
        List<Position_Employee__c> finalUniqueList = new list<Position_Employee__c>();
        map<String,Position_Employee__c> mapUniqueList = new map<String,Position_Employee__c>();
        if(otherqueryforuniqueEmp.contains('where')){
             if ((SecurityUtil.checkRead(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_READ_FIELD, false)) && 
                (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) &&
                (SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
            {
                finalList=Database.query(otherqueryforuniqueEmp+' and employee__r.employee_id__c in:uniqueEmpIdSet order by position__r.name');//[select p.Position__r.Client_Territory_Name__c, p.Position__r.Client_Territory_Code__c, p.Position__r.Client_Position_Code__c, p.Position__r.Name, p.Position__c, p.Position__r.Position_Type__c, p.Position__r.Effective_End_Date__c, p.Position__r.Effective_Start_Date__c, p.Employee__r.Employee_ID__c, p.Employee__r.Name, p.Employee__r.Id, p.Employee__c From Position_Employee__c p where employee__r.employee_id__c in:uniqueEmpIdSet];
            }
             
        }
        
        else if(!otherqueryforuniqueEmp.contains('where')){
            if ((SecurityUtil.checkRead(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_READ_FIELD, false)) && 
                (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) &&
                (SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
            {
                finalList=Database.query(otherqueryforuniqueEmp+' where employee__r.employee_id__c in:uniqueEmpIdSet');//[select p.Position__r.Client_Territory_Name__c, p.Position__r.Client_Territory_Code__c, p.Position__r.Client_Position_Code__c, p.Position__r.Name, p.Position__c, p.Position__r.Position_Type__c, p.Position__r.Effective_End_Date__c, p.Position__r.Effective_Start_Date__c, p.Employee__r.Employee_ID__c, p.Employee__r.Name, p.Employee__r.Id, p.Employee__c From Position_Employee__c p where employee__r.employee_id__c in:uniqueEmpIdSet];
            }
            
        }
        
        for(Position_Employee__c emp:finalList){
        
            mapUniqueList.put(emp.employee__r.employee_id__c,emp);
        }
        finalUniqueList = mapUniqueList.values();
      
        //Fetch all Unassigned employees from Employee
        soql = '';
        soql = 'select id, name, employee_id__c,Employee_Type__c,Job_Title__c, change_status__c,HR_Status__c from employee__c';
        list<Employee__c> unassignedEmployeesList = new list<Employee__c>();
        
        soql += ' where Id NOT in : assignedEmpIds';
        
        if (empid != null && !empid.equals('')){
            String val1='\'%' + String.escapeSingleQuotes(empid) + '%\'';
            soql += ' and (name LIKE '+val1+' or Employee_id__c LIKE '+val1+')';
        }
        
        if ((SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false))){
            unassignedEmployeesList = Database.query(soql);
        }
        
        set<id> setEmployeeIDs = new set<id>();
        for(Position_Employee__c e : finalUniqueList){
            setEmployeeIDs.add(e.employee__c);
        }
        
        for(Employee__c e : unassignedEmployeesList){
            setEmployeeIDs.add(e.id);
        }
        
        list<Employee_Address__c> listEmpAddress;
        if ((SecurityUtil.checkRead(Employee_Address__c.SObjectType, EMPLOYEE_ADDRESS_READ_FIELD, false)) &&
            (SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
        {
            listEmpAddress = [select id, name, City__c, Country__c, State__c, Pincode__c, Employee__c, Employee__r.Achievement_Index__c, Employee__r.change_status__c, Employee__r.Experience_Therapeutic_Area__c, Employee__r.Experience_Industry__c, Employee__r.Experience_Company__c from Employee_Address__c where Employee__c in:setEmployeeIDs];
        }
        
        map<string, Employee_Address__c> mapEmpEmpAddress = new map<string,Employee_Address__c>();
        for(Employee_Address__c empAdd : listEmpAddress){
            mapEmpEmpAddress.put(empAdd.Employee__c, empAdd);
        }
        
        //Add all Assigned employees from Position employee
        Integer counter=0;
        for(Position_Employee__c e : finalUniqueList){
            if(counter==0){
                if(empWrapperList.size() < 1000){       
                    empWrapperList.add(new EmployeesWrapper('Assigned',e,true,mapEmpEmpAddress.get(e.employee__c)));
                    counter++;          
                }
            }else{
                if(empWrapperList.size() < 1000)
                    empWrapperList.add(new EmployeesWrapper('Assigned',e,false,mapEmpEmpAddress.get(e.employee__c)));           
            }     
        }
      
        //Add all Unassigned employees from Employees
        for(Employee__c e : unassignedEmployeesList){
            if(counter==0){
                if(empWrapperList.size() < 1000){         
                    empWrapperList.add(new EmployeesWrapper('Unassigned',e,true,mapEmpEmpAddress.get(e.id)));
                    counter++;              
                }
            }
            
            else{
                if(empWrapperList.size() < 1000)  
                    empWrapperList.add(new EmployeesWrapper('Unassigned',e,false,mapEmpEmpAddress.get(e.id)));         
            }
        }
        
        if(empWrapperList.size()>0){
            //empChosen = empWrapperList[0].empId;

            if(empWrapperList[0].empStatus == 'Pending' || empChosen == '' || empWrapperList[0].hrstatus == 'Inactive'){ //|| empWrapperList[0].hrstatus == 'Inactive'
                assignLock = true;
            }
            manageState = empChosen;
            selectedRadio = empChosen;
            //employeeAssignmentDetails();
        }
    
    }
    
    /*************************get list of current asssignments to selected position*****************/
    public void currentAssignments(){
        try{
            currentEmpStat = new list<Employee_Status__c>();
            curAssignments  =   new list<Position_Employee__c>();
            curAssignments  =   RosterUtility.getPositionEmployeByPoistionId(territoryIds);//filling current assignments list for selected Position
            
            wrapperListCurAssign = new list<wrapperCurrentAssignments>();
            Set<Id> setEmpIds = new Set<Id>();
            map<Position_Employee__c,Id> mapPosEmpId = new map<Position_Employee__c,Id>();
            if(posEmp.size()>0){
                for(Position_Employee__c p:posEmp){
                    curAssignments.add(p);
                    setEmpIds.add(p.employee__c);
                    mapPosEmpId.put(p,p.employee__c);
                }
            }
            if(listEmpStat.size() > 0){
                for(Employee_status__c empstat : listEmpStat){
                    currentEmpStat.add(empstat);
                }
            }
            setOfEmployees = new Set<Id>();
            map<Id,Employee__c> mapIdEmp = new map<Id,Employee__c>();
            
            list<Employee__c> empDetails = new list<Employee__c>();
            if ((SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false))){
            empDetails = [select id,name,Manager__c,Manager__r.Name,Manager__r.Current_Territory__c,employee_Id__c from Employee__c where id in:setEmpIds];
            }
            
            
            for(Employee__c emp:empDetails){
            	System.debug(' emp --'+emp);
                mapIdEmp.put(emp.id,emp);
            }
        
            Set<Position_Employee__c> setPE = new set<Position_Employee__c>();
            setPE.addAll(posEmp);
            
            Integer uniqueNumber = 1;
            for(Position_Employee__c p:curAssignments){
        		System.debug('pos emp ---'+p);
                setOfEmployees.add(p.employee__c);
                // code for merge request
                String managerid = '';
                String managerName = '';
                System.debug('mapIdEmp ---'+mapIdEmp);
                if(mapIdEmp.size() > 0){
                	System.debug(' map --'+mapIdEmp.get(p.employee__c));
                	if(mapIdEmp.get(p.employee__c) != null){
		                if(mapIdEmp.get(p.employee__c).Manager__c != null){
		                	managerid = mapIdEmp.get(p.employee__c).Manager__c;
		                	managerName = mapIdEmp.get(p.employee__c).Manager__r.Name;
		                }
                	}
                }
                if(setPE.contains(p)){
                    if(mapIdEmp.get(mapPosEmpId.get(p)).employee_id__c != null){ 
                    	wrapperListCurAssign.add(new wrapperCurrentAssignments(uniqueNumber, mapIdEmp.get(mapPosEmpId.get(p)).employee_id__c,mapIdEmp.get(mapPosEmpId.get(p)).name,p, true, managerid, managerName ));
                    }               
                }
                else{   
                    if(p.employee__r.employee_id__c != null){  
                    	wrapperListCurAssign.add(new wrapperCurrentAssignments(uniqueNumber, p.employee__r.employee_id__c,p.employee__r.name,p, false,managerid, managerName  ));
                    }
                }
                uniqueNumber = uniqueNumber + 1;
            }
        }catch(exception ex){
            SalesIQLogger.logMessage(ex);
        }
    }
    
    /*************************reason code dropdown************************************/
    public List<SelectOption> reasonCodeList
    {
        get
        {
            List<SelectOption> options = new List<SelectOption>();
            try{
                Schema.DescribeFieldResult fieldResult = Position_Employee__c.reason_code__c.getDescribe();
                List<Schema.PicklistEntry> ple = fieldResult.getPicklistValues();
                for( Schema.PicklistEntry f : ple)
                    options.add(new SelectOption(f.getLabel(), f.getValue()));
            }catch(exception ex){
                SalesIQLogger.logMessage(ex);
            }
            return options;
        }
    }
    
    /*
     * dropdown of assignment type  
     * @return void
    */ 
    public List<SelectOption> assignmenttypeList
    {
        get
        {
            List<SelectOption> options = new List<SelectOption>();
            try{
                Schema.DescribeFieldResult fieldResult = Position_Employee__c.Assignment_Type__c.getDescribe();
                List<Schema.PicklistEntry> ple = fieldResult.getPicklistValues();
                for( Schema.PicklistEntry f : ple)
                    options.add(new SelectOption(f.getLabel(), f.getValue()));
            }catch(exception ex){
                SalesIQLogger.logMessage(ex);
            }
            return options;
        }
    }
    
    /*
     * method for adding new employee to selected Position
     * @return void
     */ 
    public void addAssignment(){
        try{
            
            Employee__c empChosenRecord ;
            
            if(empChosen != null){
                empChosenRecord = RosterUtility.getEmployeeById(new Set<String>{empChosen}).get(0) ;
                   
                Position_Employee__c p = new Position_Employee__c();
                p.employee__c = empChosen;
                p.employee__r = empChosenRecord ;
                p.position__c = terrId;
                p.assignment_type__c = 'None';
                p.reason_code__c = 'None';
                p.isNew__c = true;

                system.debug('--new start date ' + teamInstanceEffectiveStartDate);
                if(isFutureTeamInstance){
                    p.Effective_Start_Date__c = selectedURLPosition.Effective_start_Date__c;
                    p.Effective_End_Date__c = selectedURLPosition.Effective_End_Date__c ;
                }
                else{
                    p.Effective_Start_Date__c = Date.Today();
                    p.Effective_End_Date__c = selectedURLPosition.Effective_End_Date__c ;
                }
    
                p.status__c = 'Pending';
                
                posEmp.add(p);
                
                Employee_Status__c objEmpStas = new Employee_Status__c();
                objEmpStas.Employee__c = empChosen;
                objEmpStas.Employee_Status__c = 'Assigned';
                listEmpStat.add(objEmpStas);
                currentAssignments();
            }
        }catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
           
        }
    }
    /*
     * save updated assignments for selected Position
     * @return void
    */ 
    
    public boolean showError{get;set;}
    public String employeeAssignedMessage {get;set;}
    
    public void saveAssignments(){
        Savepoint sp = Database.setSavepoint();
        try{
        	
        	showError = false;
            showSavePopup = false;
            isSaveAssignSuccess = false;
            String primaryPosition;
            Set<id> setEmpIds = new Set<Id>();
            map<Id,list<Position_Employee__c>> mapEmpPos = new map<Id,list<Position_Employee__c>>();
            
            Integer primaryCounter=0;   
            //Boolean showError;
            Boolean dateError;
            Boolean EnddateError;
            EnddateError = false;
            Boolean startEndDateError;
            String dateErrorEmployee;
            map<Id,Position_Employee__c>posIdposEmpVal = new map<id,position_Employee__c>();
            Set<Id>primaryPosemp = new Set<Id>();
            boolean posStartEndDateError = false; 
            boolean employeeHireTerminationDateError = false;
            Date empHireDate;
            Date empTerminationDate;
            boolean teamInstanceDateError = false;
            
            for(wrapperCurrentAssignments wr : wrapperListCurAssign){
            
                setEmpIds.add(wr.pEmp.employee__c);
                if(mapEmpPos.get(wr.pEmp.employee__c) != null){
                    list<Position_Employee__c> listPE = mapEmpPos.get(wr.pEmp.employee__c);
                    listPE.add(wr.pEmp);
                    mapEmpPos.put(wr.pEmp.employee__c,listPE);
                }
                else{
                    list<Position_Employee__c> listPE1 = new list<Position_Employee__c>();
                    listPE1.add(wr.pEmp);
                    mapEmpPos.put(wr.pEmp.employee__c,listPE1);
                }
                
                
                posIdposEmpVal.put(wr.pEmp.position__c,wr.pEmp);
                if(wr.pEmp.Assignment_Type__c=='Primary'){
                    primaryCounter++;
                    primaryPosemp.add(wr.pEmp.id);
                }
                
                if(wr.pEmp.Effective_Start_Date__c==null){
                    dateError = true;
                    dateErrorEmployee = wr.pEmp.employee__r.name;
                }
                
                if(wr.pEmp.Effective_End_Date__c==null){
                    EnddateError = true;
                    dateErrorEmployee = wr.pEmp.employee__r.name;
                }
    
                if( (wr.pEmp.Effective_End_Date__c < wr.pEmp.Effective_Start_Date__c)){
                    startEndDateError = true;
                }

                if(wr.pEmp.Effective_Start_Date__c != null && wr.pEmp.Effective_Start_Date__c < teamInstanceEffectiveStartDate){
                    teamInstanceDateError = true;
                }

                if(wr.pEmp.Effective_End_Date__c != null && wr.pEmp.Effective_End_Date__c > teamInstanceEffectiveEndDate){
                    teamInstanceDateError = true;
                }    
                
                if(selectedURLPosition != null){
                    system.debug('wr.pEmp.Effective_start_Date__c '+wr.pEmp.Effective_start_Date__c + '###' + selectedURLPosition.Effective_start_Date__c + '###' + wr.pEmp.Effective_end_Date__c + '###' +selectedURLPosition.Effective_end_Date__c);
                    if( !(wr.pEmp.Effective_start_Date__c >= selectedURLPosition.Effective_start_Date__c && wr.pEmp.Effective_end_Date__c <= selectedURLPosition.Effective_end_Date__c) ){
                        posStartEndDateError = true;
                    }
                }

                //employeeHireTerminationDateError
                if(wr.pEmp.Employee__r.Original_Hire_Date__c != null && wr.pEmp.Employee__r.HR_Termination_Date__c != null){
                
                    if(!(wr.pEmp.Effective_start_Date__c >= wr.pEmp.Employee__r.Original_Hire_Date__c && wr.pEmp.Effective_end_Date__c <= wr.pEmp.Employee__r.HR_Termination_Date__c)){
                        employeeHireTerminationDateError = true;
                        empTerminationDate = wr.pEmp.Employee__r.HR_Termination_Date__c;
                        empHireDate = wr.pEmp.Employee__r.Original_Hire_Date__c;
                    }
                }
            }
            
            boolean isSameEmployeeOverlapping = false;
            
            for(string emp : mapEmpPos.keyset()){
                Map<Date, Position_Employee__c> tempMapSorting1 = new Map<Date, Position_Employee__c>();
                boolean alreadyExists1 = false;
                list<Position_Employee__c> listPosEmp = mapEmpPos.get(emp);
                
                for( Position_Employee__c objPE1 : listPosEmp ){
                    if(tempMapSorting1.containsKey(objPE1.effective_start_Date__c)){
                        alreadyExists1 = true;
                    }
                    else {
                        tempMapSorting1.put(objPE1.effective_start_Date__c, objPE1);
                    }
                    
                    if(alreadyExists1) {
                        break;
                    }   
                }
                
                if(alreadyExists1 == false)
                {
                    List<Date> allUniqueStartDates = new List<Date>();
                    
                    for(Date dt :tempMapSorting1.keySet())
                    {
                        allUniqueStartDates.add(dt);
                    }
                    allUniqueStartDates.sort();
                    
                    listPosEmp = new List<Position_Employee__c>();
                    
                    for(Date tempDt : allUniqueStartDates)
                    {
                        if(tempMapSorting1.get(tempDt).effective_start_Date__c < tempMapSorting1.get(tempDt).effective_end_Date__c){
                            listPosEmp.add(tempMapSorting1.get(tempDt));
                        }
                        
                    }
                    
                    Date startDate;
                    Date endDate;
                            
                    for(Position_Employee__c wr : listPosEmp){                     
                        if(startDate==null && endDate==null){                           
                            startDate = wr.effective_start_Date__c;
                            endDate = wr.Effective_End_Date__c;                            
                        }
                        
                        else{                       
                            if(wr.Effective_Start_Date__c <= endDate){   
                                isSameEmployeeOverlapping = true;                         
                                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, system.label.Overlapping_Date_Message);
                                //ApexPages.addMessage(myMsg); 
                                //notification-Toast
                                setMessageParams( System.Label.Message_Theme_Error, system.label.Overlapping_Date_Message);                           
                            }                           
                            else{                           
                                startDate = wr.effective_start_Date__c;
                                endDate = wr.Effective_End_Date__c;                            
                            }                       
                        }
                    }
                }
                else{
                    isSameEmployeeOverlapping = true;
                    ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, system.label.Overlapping_Date_Message);
                    //ApexPages.addMessage(myMsg);
                    //notification-Toast
                    setMessageParams( System.Label.Message_Theme_Error, system.label.Overlapping_Date_Message);                           
                            
                }            
            }
               
            String assignedEmployee;
            
            if ((SecurityUtil.checkRead(Position_Employee__c.SObjectType,POSITION_EMPLOYEE_READ_FIELD, false)) &&
                (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) &&
                (SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
            {
                for(Position_Employee__c pEmp:[select assignment_type__c,position__c,employee__r.name,  employee__c,position__r.name,
                                               effective_start_date__c,effective_end_date__c   from Position_Employee__c 
                                               where employee__c in:setOfEmployees and position__c!=:terrId and employee__c != null and Position__c != null ]){
                    
                    //add check for only active assignments--effective end date check        
                    if(mapEmpPos.get(pEmp.employee__c) != null){
                        for( Position_Employee__c objPE : mapEmpPos.get(pEmp.employee__c)){
                            if(pEmp.assignment_type__c=='Primary' && objPE.assignment_type__c =='Primary'){
                                if(pEmp.effective_start_date__c < pEmp.effective_end_date__c && objPE.effective_start_date__c < objPE.effective_end_date__c ){
                                    Date oldStartDate = objPE.effective_start_date__c;
                                    Date oldEndDate = objPE.effective_end_date__c;
                                        
                                    Date newStartDate = pEmp.effective_start_date__c;
                                    Date newEndDate = pEmp.effective_end_date__c;
                                         
                                    if(!((oldStartDate < newStartDate && oldEndDate < newStartDate) || (oldStartDate > newEndDate && oldEndDate > newEndDate))){
                                        showError = true;
                                        primaryPosition = pEmp.position__r.name;
                                        assignedEmployee = pEmp.employee__r.name;
                                        break;
                                    }                
                                }
                            }
                        }
                    }
                }
            }
            
            /*******Validation Rule: Same employee can't be assigned as primary for multiple positions in given period**************/
            if(dateError == true){
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, string.format(System.Label.PositionFieldBlankPrompt,new list<string>{System.Label.Start_Date_Manage}));
                //ApexPages.addMessage(myMsg);
                //notification-Toast
                setMessageParams( System.Label.Message_Theme_Error, string.format(System.Label.PositionFieldBlankPrompt,new list<string>{System.Label.Start_Date_Manage}));
            }
            else if(EnddateError == true){
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, string.format(System.Label.PositionFieldBlankPrompt,new list<string>{System.Label.End_Date}));                
                //ApexPages.addMessage(myMsg);
                //notification-Toast
                setMessageParams( System.Label.Message_Theme_Error, string.format(System.Label.PositionFieldBlankPrompt,new list<string>{System.Label.End_Date}));
            }
            else if(posStartEndDateError == true){
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, string.format(System.Label.EmployeeAssignmentDateBetweenPosition, new list<string>{selectedURLPosition.Effective_start_Date__c.format(), selectedURLPosition.Effective_end_Date__c.format()}));
                //ApexPages.addMessage(myMsg);
                 //notification-Toast
                setMessageParams( System.Label.Message_Theme_Error, string.format(System.Label.EmployeeAssignmentDateBetweenPosition, new list<string>{selectedURLPosition.Effective_start_Date__c.format(), selectedURLPosition.Effective_end_Date__c.format()}));
            
            }
            else if(employeeHireTerminationDateError == true){
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, string.format(System.Label.Employee_Assignment_Date_Error, new list<string>{empHireDate.format(), empTerminationDate.format()}));
                //ApexPages.addMessage(myMsg);
                //notification-toast
                setMessageParams( System.Label.Message_Theme_Error, string.format(System.Label.Employee_Assignment_Date_Error, new list<string>{empHireDate.format(), empTerminationDate.format()}) );
            }
            else if(showError == true){
            	
            	employeeAssignedMessage = string.format(System.Label.Already_Assign_Employee, new list<string>{assignedEmployee, primaryPosition});
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, string.format(System.Label.Already_Assign_Employee, new list<string>{assignedEmployee, primaryPosition}));
                //ApexPages.addMessage(myMsg);
                //notification-toast
                setMessageParams( System.Label.Message_Theme_Error,employeeAssignedMessage);
                
            }
            else if(startEndDateError == true){
                    ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, System.Label.End_Date_Less);
                //ApexPages.addMessage(myMsg);
                //notification-toast
                setMessageParams( System.Label.Message_Theme_Error,System.Label.End_Date_Less);
            }
            else if(teamInstanceDateError){
                ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR, 'Position Employee Start and End date should lie between Team Instance Start (' + teamInstanceEffectiveStartDate + ') and End (' + teamInstanceEffectiveEndDate + ') Date.');
                //ApexPages.addMessage(myMsg);
                //notification-toast
                setMessageParams( System.Label.Message_Theme_Error,'Position Employee Start and End date should lie between Team Instance Start (' + teamInstanceEffectiveStartDate + ') and End (' + teamInstanceEffectiveEndDate + ') Date.');
            }
            else if( isSameEmployeeOverlapping){
                
            }
            else{
                boolean goAhead = false;
                if(primaryCounter>1){
                    Map<Date, wrapperCurrentAssignments> tempMapSorting = new Map<Date, wrapperCurrentAssignments>();
                    boolean alreadyExists = false;
                    List<wrapperCurrentAssignments> wrapperListCurAssign2;
                    for(wrapperCurrentAssignments wr : wrapperListCurAssign){
                        if(tempMapSorting.containsKey(wr.pemp.effective_start_Date__c)){
                            if(wr.pemp.assignment_type__c == 'Primary' && tempMapSorting.get(wr.pemp.effective_start_Date__c).pemp.assignment_type__c == 'Primary')
                                alreadyExists = true;
                        }else{
                          tempMapSorting.put(wr.pemp.effective_start_Date__c, wr);
                        }
                        
                        if(alreadyExists){
                            break;
                        }   
                    }
                          
                    if(alreadyExists == false){
                        List<Date> allUniqueStartDates = new List<Date>();
                        for(Date dt :tempMapSorting.keySet()){
                            allUniqueStartDates.add(dt);
                        }
                        allUniqueStartDates.sort();
                        wrapperListCurAssign2 = new List<wrapperCurrentAssignments>();
                                
                        for(Date tempDt : allUniqueStartDates)
                        {
                            if(tempMapSorting.get(tempDt).pemp.effective_start_Date__c < tempMapSorting.get(tempDt).pemp.effective_end_Date__c){
                                wrapperListCurAssign2.add(tempMapSorting.get(tempDt));
                            }
                        }
                            
                        Date startDate;
                        Date endDate;
                            
                        for(wrapperCurrentAssignments wr : wrapperListCurAssign2){
                            if(wr.pemp.assignment_type__c=='Primary'){                      
                                if(startDate==null && endDate==null){                           
                                    startDate = wr.pemp.effective_start_Date__c;
                                    endDate = wr.pemp.Effective_End_Date__c;                            
                                }else{                       
                                    if(wr.pemp.Effective_Start_Date__c <= endDate){                            
                                        //message = system.Label.Date_Overlapping_On_Same_Position;
                                        goAhead = true;
                                        //ApexPages.addMessage(myMsg);                           
                                    }else{                           
                                        startDate = wr.pemp.effective_start_Date__c;
                                        endDate = wr.pemp.Effective_End_Date__c;                            
                                    }                       
                                }
                            }
                        }
                        //notification-toast
                        if(goAhead){
                            setMessageParams( System.Label.Message_Theme_Error, system.Label.Date_Overlapping_On_Same_Position);
                        }

                    }else{
                        goAhead = true;
                        //ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.ERROR,system.Label.Date_Overlapping_On_Same_Position);
                        //ApexPages.addMessage(myMsg);
                        //notification-toast
                        setMessageParams( System.Label.Message_Theme_Error, system.Label.Date_Overlapping_On_Same_Position);
                    }
                }  
                        
                if(goAhead == false){
                    
                    set<string> setPosEmpID = new set<string>();
                    Change_request__c CR = null;
                    list<User> usr = new list<User>();
                    list<string> response = new list<string>();
                    list<Position_Employee__c> posEmpCRlist = new list<Position_Employee__c>();
                        //boolean IsAutoApproved = false; 
                        string strStatus = '';
                        CR = SalesIQUtility.createChangeRequestRoster(SalesIQGlobalConstants.REQUEST_STATUS_PENDING, system.today(), SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT, teamInstanceVal, SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT, SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT,'');
                        CR.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;
                        CR = SalesIQUtility.CreateApprovals(CR, usr, response,new list<Object>());
                        /*list<User> usr = SalesIQUtility.ReturnUserBasedOnProfile(SalesIQGlobalConstants.HO_PROFILE); 
                        if(AlignmentUtility.IsHOUserLoggedIn(usr)){
                            IsAutoApproved = true;
                            strStatus = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
                        }
                        else{
                            strStatus = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;
                        }*/
                        system.debug('********* CR ' + CR);
                        system.debug('******** Users ' + usr);
                        system.debug('********* status ' + CR.Status__c);
                    for(Position_Employee__c objPosEmp : posEmp){
                        setPosEmpID.add(objPosEmp.id);
                    }
                            
                    for(Position_Employee__c objPE : curAssignments){
                        if(objPE.employee__c != null){
                            if(setPosEmpID.contains(objPE.id)){
                                objPE.IsNew__c = true;
                                objPE.status__c = 'Pending';
                                posEmpCRlist.add(objPE);
                            }else if(objPE.Last_Approved_Start_Date__c != objPE.Effective_Start_Date__c || objPE.Last_Approved_Assignment_Type__c != objPE.Assignment_Type__c || objPE.Last_Approved_End_Date__c != objPE.Effective_End_Date__c){
                                objPE.status__c = 'Pending';
                                posEmpCRlist.add(objPE);
                            }
                        }
                    }

                    if(posEmpCRlist.size() == 0){
                        //system.assert(false, 'Inside If check of change');
                        ApexPages.Message myMsg = new ApexPages.Message(ApexPages.Severity.INFO, System.label.ManageAssignment_No_Change);
                        //ApexPages.addMessage(myMsg); 
                        //notification-toast
                        setMessageParams( System.Label.Message_Theme_Error , System.label.ManageAssignment_No_Change );
                    }
                            
                    if(posEmpCRlist.size() > 0){
                        list<CR_Employee_Assignment__c> crEmpAssgList;
                           
                            if(usr!=null && usr.size() > 0){
                                system.debug('********* CR.Status__C ' +CR.Status__c);
                                strStatus = CR.Status__c;
                            if((SecurityUtil.checkInsert(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_INSERT_FIELD, false)) && 
                                (SecurityUtil.checkUpdate(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_INSERT_FIELD, false))) {
                                upsert curAssignments;
                            }
                            set<string> setEmployeeIds = new set<string>();
                            for(Position_Employee__c obj : posEmpCRlist){
                                setEmployeeIds.add(obj.employee__c);
                            }
                                    
                            list<employee__c> listEmp = new list<employee__c>();
                                    
                            if(SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_UPDATE_FIELD, false)) {
                                listEmp = [select id, name, change_status__c from employee__c where id in: setEmployeeIds];
                            }
                                    
                            for(employee__c emp : listEmp){
                               emp.change_status__c = strStatus;
                            }
                                        
                            //if(SecurityUtil.checkUpdate(Employee__c.SObjectType, EMPLOYEE_UPDATE_FIELD, false)) {   
                                update listEmp;
                            //}
                                        
                            //Change_request__c CR = SalesIQUtility.createChangeRequestRoster(SalesIQGlobalConstants.REQUEST_STATUS_PENDING, system.today(), SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT, teamInstanceVal, SalesIQGlobalConstants.ROSTER, SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT,'');  
                            //CR.Is_Auto_Approved__c = IsAutoApproved;
                            CR.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;  
                            CR.source_position__c = terrId;
                            CR.destination_position__c = terrId;                             
                            CR = AlignmentUtility.AssignApproval(CR, usr, integer.valueOf(TotalApproval__c.getValues('Approvals').No_Of_Approval__c));
                                
                            list<string> CHANGE_REQUEST_INSERT_FIELD = new list<string>{'Status__c','RecordTypeID__c','Execution_Date__c','Source_Position__c','Parent_Change_Request_ID__c', 'Account_Moved_Id__c', 'Change_String_Value__c', 'Request_Type_Change__c', 'Destination_Position__c', 'Reason__c', 'Team_Instance_ID__c', 'Source_Positions__c', 'Destination_Positions__c', 'RecordtypeId'};
                            //if(SecurityUtil.checkInsert(Change_Request__c.SObjectType, CHANGE_REQUEST_INSERT_FIELD, false)) {
                                insert CR;                              
                            //} 
                                    
                            crEmpAssgList = SalesIQUtility.createCRempAssgn(CR, posEmpCRlist);
                                    
                            //if(SecurityUtil.checkInsert(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_INSERT_FIELD, false)) {
                                insert crEmpAssgList;                               
                            //}
        
                            
                            SalesIQUtility.SubmitSelfApproval(CR.Id,strStatus);
                            isSaveAssignSuccess = true; 
                            showCRMsg = true;
                            crname = AlignmentUtility.getRequestNameByRequestId(CR.Id);
                            
                            setMessageParams( System.Label.Message_Theme_Success, 'Change Request '+ crname + ' has been submitted.'); 

                            System.debug('crname :::'+crname);
                                
                            wrapperListCurAssign = null;
                            empChosen = null;
                                        
                            posEmp = new list<Position_Employee__c>();
                            currentAssignments();
                            for(wrapperCurrentAssignments wrapper : wrapperListCurAssign){
                                wrapper.isEditable = false;
                            }
                                }else{
                                    system.debug('********* Inside ELSE');
                                    //ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.ERROR,System.Label.No_Approval_Found)); 
                                    //notification-toast
                                    setMessageParams( System.Label.Message_Theme_Error, System.Label.No_Approval_Found); 
                                }
                            }
                        } 
                    
                    //runSearch();
                    list<CR_Employee_Assignment__c> listPosEmpAssgn = new list<CR_Employee_Assignment__c>();
                    
                    if ((SecurityUtil.checkRead(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_FIELD, false)) &&
                       (SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELD, false))){  
                        listPosEmpAssgn = [select id, name, Change_Request_ID__r.status__c, Position_ID__c from CR_Employee_Assignment__c where Position_ID__c=: terrID and Change_Request_ID__r.status__c = 'Pending' and Change_Request_ID__r.Request_Type_Change__c = 'Employee Assignment'];
                    }
                    
                    if(listPosEmpAssgn.size() > 0){
                        isLock = true; 
                        assignlock = isLock;
                    }
                }   
        }
        catch(exception ex){
            Database.rollBack(sp); 
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
        }
    }
    
    public void  closeCRMsg()
    {
        showCRMsg = false;
    }
    public String manageState{get;set;}
    
    /**************Details of current,past and future assignments on sleected position**************/
    public void employeeAssignmentDetails(){
        try{
            System.debug('in assignment details---------->>>' + empChosen);
            if ((SecurityUtil.checkRead(Employee__c.SObjectType, EMPLOYEE_READ_FIELD, false)))
            {
                Employee__c selectedEmp = [select name,Change_status__c,HR_Status__c from Employee__c where id=:empChosen LIMIT 1];
                selectedEmployeeName = selectedEmp.name;
                assignLock = isLock;
                if(selectedEmp.Change_status__c=='Pending' || selectedEmp.HR_Status__c == 'Inactive')
                {
                    assignLock = true;  
                }
            }
            
            
            list<Position_Employee__c> pEmp ;
            if ((SecurityUtil.checkRead(Position_Employee__c.SObjectType, POSITION_EMPLOYEE_INSERT_FIELD, false)) &&
               (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)))
            {
               pEmp= [select id,name,employee__c, Assignment_Type__c, position__c, position__r.team_id__r.name,position__r.name,
                        position__r.position_type__c,effective_start_date__c, effective_end_date__c,position__r.Assignment_status__c,Reason_Code__c
                        from Position_Employee__c 
                        where employee__c=:empChosen and position__c != null];
                                    
            }
            
            
            list<CR_Employee_Assignment__c> CRemp;
            if ((SecurityUtil.checkRead(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_FIELD, false)) &&
               (SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELD, false)) && 
               (SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELD, false)))
            {                      
                CRemp = [select id, Employee_ID__c, Position_ID__c, Position_ID__r.team_ID__r.name,
                            Position_ID__r.position_type__c,Position_ID__r.name, Change_Request_ID__r.Execution_Date__c,Position_ID__r.Assignment_status__c
                            from CR_Employee_Assignment__c
                            where employee_ID__c=:empChosen ];
            }
            
               
                                                    
            empAssignmentList = new list<wrapperEmployeeAssignment>();      
            for(Position_Employee__c p : pEmp){     
                if(p.Assignment_Type__c != 'Vacant' && p.Assignment_Type__c != 'Filled'){
                    empAssignmentList.add(new wrapperEmployeeAssignment(p.position__c, p.position__r.name,p.effective_start_date__c,p.effective_end_date__c,p.position__r.team_ID__r.name,p.position__r.position_type__c, p.Assignment_Type__c,p.Reason_Code__c));        
                }
            }
        
            selectedRadio = empChosen;
        }catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
            
        }
    }
    
    /**********************Cancel changes made in current assignments****************************************/
    public PageReference cancelChanges(){
        try{
            if(changeRequest==null){
                PageReference moveToSwap = Page.Alignment ;
                moveToSwap.setRedirect(true);
                return moveToSwap;
            }else{
                PageReference moveToSwap = Page.RosterManagementDataTable ;
                moveToSwap.setRedirect(true);
                return moveToSwap;
            }
        }catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
            return null;
        }
    }
    
    public void searchBoxSupport(){ 
        selectedRadio = empChosen;
    }
    
    /*********************moving back to alignment workflow**********************/
    
    public PageReference backToAlignment(){
        PageReference reference = Page.Alignment ;
        try{            
            reference.setRedirect(true);
        }catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
        }
        return reference;
    }
    
    public void deleteAssignment(){     
        try{    
        	System.debug('deleteId --'+deleteId);
        	System.debug('wrapperListCurAssign --'+wrapperListCurAssign.size() +', data -'+wrapperListCurAssign);
        	System.debug('posEmp ---'+posEmp);
            if(deleteId != null){

                Integer index = 0;
                string employeeTOdelete = '';
                for(Position_Employee__c posEmpObj : posEmp){
                	// code for merge request
                	if(wrapperListCurAssign.size() == 1){
                		if(wrapperListCurAssign.get(0).pEmp.Employee__c == posEmpObj.Employee__c && wrapperListCurAssign.get(0).pEmp.Effective_Start_Date__c == posEmpObj.Effective_Start_Date__c && wrapperListCurAssign.get(0).pEmp.Effective_End_Date__c == posEmpObj.Effective_End_Date__c && wrapperListCurAssign.get(0).pEmp.Assignment_Type__c == posEmpObj.Assignment_Type__c){
	                        System.debug('posEmp ----- '+posEmp);
	                        posEmp.remove(index); 
	                        employeeTOdelete = posEmpObj.Employee__c;
	                        break;
                	
                		}
                	}else{
	                    if(wrapperListCurAssign.get(Integer.valueOf(deleteId) - 2).pEmp.Employee__c == posEmpObj.Employee__c && wrapperListCurAssign.get(Integer.valueOf(deleteId) - 2).pEmp.Effective_Start_Date__c == posEmpObj.Effective_Start_Date__c && wrapperListCurAssign.get(Integer.valueOf(deleteId) - 2).pEmp.Effective_End_Date__c == posEmpObj.Effective_End_Date__c && wrapperListCurAssign.get(Integer.valueOf(deleteId) - 2).pEmp.Assignment_Type__c == posEmpObj.Assignment_Type__c){
	                        System.debug('posEmp ----- '+posEmp);
	                        posEmp.remove(index); 
	                        employeeTOdelete = posEmpObj.Employee__c;
	                        break;
	                    }
                    }
                    index = index + 1;
                }

                index = 0;
                for(Employee_status__c empStaObj : listEmpStat){
                    if(empStaObj.Employee__c == employeeTOdelete){
                        listEmpStat.remove(index);
                        break;
                    }
                    index = index + 1;
                }
            }   
            currentAssignments();           
        }
        catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
        }        
    } 
    
    
    public void makeFieldsEditable()
    {
        try{
            for(wrapperCurrentAssignments wc:wrapperListCurAssign)
            {
                if(wc.uniqueNumber == selectedID)
                {
                    wc.isEditable = true;
                }
            }
        }catch(exception ex){
            SalesIQLogger.logCatchedException(ex, true, SalesIQLogger.POSITION_MODULE);
        }   
    }
    
    public class wrapperCurrentAssignments{
        //To make only a particular row editable at a time (Bug : Edition of one the employee assignments with the same employee id, brings up all the employee assignments to editable mode)
        public Integer uniqueNumber{get;set;} 
        public String empId{get;set;}
        public String empName{get;set;}
        public Position_Employee__c pEmp{get;set;}
        public boolean isEditable {get;set;}

        public String getStartDateFormatted() {
            return pEmp.Effective_Start_Date__c != null ? pEmp.Effective_Start_Date__c.format() : '';
        }

        public String getEndDateFormatted() {
            return pEmp.Effective_End_Date__c != null ? pEmp.Effective_End_Date__c.format() : '' ;
        }
	   //added since manager was not populated while employee is assogned to selected position after click on Assign Rep
	   public String manager {get;set;}
        public String managerName {get;set;}
        public wrapperCurrentAssignments(Integer uniqueNumber, String empId,String empName,Position_Employee__c pEmp, boolean isEditable, String empManager, String ManagerName){        
            this.empId = empId;
            this.empName = empName;
            this.pEmp =pEmp;
            this.isEditable = isEditable;  
            this.uniqueNumber = uniqueNumber;  
	     this.manager = manager; 
            this.managerName = managerName;  
        }
    }
    
    /******************wrapper List for assignments on selected employee***************************/
    public class wrapperEmployeeAssignment{
        public String pos{get;set;}
        public string posId{get;set;}
        public Date startDate{get;set;}
        public Date endDate{get;set;}
        public String team{get;set;}
        public String posType{get;set;}
        public String assignmentType{get;set;}
        public String reasonCode {get;set;}

        public String getStartDateFormatted() {
            return startDate != null ? startDate.format() : '';
        }

        public String getEndDateFormatted() {
            return endDate != null ? endDate.format() : '' ;
        }
    
        public wrapperEmployeeAssignment(string posId, String pos,Date startDate,Date endDate, String team,String posType, String assignmentType ,String reasonCode){           
            this.posId = posId;
            this.pos = pos;
            this.startDate = startDate;
            this.endDate = endDate; 
            this.team = team;
            this.posType = posType;
            this.AssignmentType = assignmentType;
            this.reasonCode = reasonCode;
        }
    }
    
    /******************wrapper List for current assignments to selected Position********************************/
    public class EmployeesWrapper{
        public string empId{get;set;}
        public string empType{get;set;}
        public string empName{get;set;}
        public string emp_Id{get;set;}
        public string EmployeeType{get;set;}
        public string JobTitle{get;set;}
        public string posEmpId{get;set;}
        public string positionName{get;set;}
        public string positionCode{get;set;}
        public string positionType{get;set;}
        public date positionStart{get;set;}
        public date positionEnd{get;set;}
        public boolean isChecked{get;set;}
        public Employee_Address__c empAddObj{get;set;}
        public string empStatus {get;set;}
        public string hrstatus {get;set;}
        public EmployeesWrapper(string empType, Employee__c emp,boolean isChecked, Employee_Address__c empAddObj){
            this.empId = emp.Id;
            this.empType = 'Unassigned';
            this.empName = emp.Name;
            this.emp_Id = emp.Employee_ID__c;
            this.EmployeeType = emp.Employee_Type__c;
            this.JobTitle = emp.Job_Title__c;
            this.isChecked = isChecked;
            this.empAddObj = empAddObj;
            this.empStatus = emp.Change_Status__c;
            this.hrstatus = emp.HR_Status__c;
            
        }
        public EmployeesWrapper(string empType, Position_Employee__c posEmp,boolean isChecked, Employee_Address__c empAddObj){
            this.empId = posEmp.Employee__c;
            this.empType = 'Assigned';
            this.empName = posEmp.Employee__r.Name;
            this.emp_Id = posEmp.Employee__r.Employee_ID__c;
            this.EmployeeType = posEmp.Employee__r.Employee_Type__c;
            this.JobTitle = posEmp.Employee__r.Job_Title__c;
            this.positionName = posEmp.Position__r.Client_Territory_Name__c;
            this.positionCode = posEmp.Position__r.Client_Position_Code__c;
            this.positionType = posEmp.Position__r.Position_Type__c;
            this.positionStart = posEmp.Effective_Start_Date__c;
            this.positionEnd = posEmp.Effective_End_Date__c;
            this.isChecked = isChecked;
            this.empAddObj = empAddObj;
            this.empStatus = posEmp.employee__r.change_Status__c;
            this.hrstatus = posEmp.employee__r.HR_Status__c;
            
        }
    }

    public void setMessageParams(String svrty, String messageText){
        showMessage = true;
        severity = String.valueOf(svrty);
        message += '<br/>';
        message += messageText;
    }

    public void hideToast(){
        message = '';
        showMessage = false;
    }
    
    //Read Objects
    static List<String> POSITION_READ_FIELD = new List<String>{'id','Client_Territory_Name__c','Client_Territory_Code__c','position_type__c','Effective_Start_Date__c','Effective_End_Date__c','Client_Position_Code__c','Name'};
    static List<String> TEAM_READ_FIELD = new List<String>{'name', 'Type__c'};
    static List<String> CR_EMPLOYEE_ASSIGNMENT_INSERT_FIELD = new List<String>{'name','Employee_ID__c','Change_Request_ID__c', 'Position_ID__c','After_Assignment_Type__c', 'After_Effective_Start_Date__c', 'After_Effective_End_Date__c', 'Before_Assignment_Type__c', 'Before_Effective_Start_Date__c', 'Before_Effective_End_Date__c', 'isnew__c'};
    static List<String> CR_EMPLOYEE_ASSIGNMENT_FIELD = new List<String>{'id','Employee_ID__c','Change_Request_ID__c', 'Position_ID__c'};
    static List<String> POSITION_EMPLOYEE_READ_FIELD = new List<String>{'id','Position__c','employee__c','Reason_Code__c','Effective_Start_Date__c','Effective_End_Date__c','Assignment_Type__c'};
    static List<String> EMPLOYEE_READ_FIELD = new List<String>{'name','Employee_ID__c','HR_Status__c','id', 'Achievement_Index__c', 'change_status__c', 'Experience_Therapeutic_Area__c', 'Experience_Industry__c', 'Experience_Company__c'};
    static List<String> CHANGE_REQUEST_READ_FIELD = new List<String>{'Execution_Date__c', 'status__c', 'Request_Type_Change__c', 'name'};
    static List<String> EMPLOYEE_ADDRESS_READ_FIELD = new List<String>{'id','city__c', 'Country__c', 'State__c', 'Pincode__c', 'Employee__c'};
    //Insert Objects
    static List<String> EMPLOYEE_UPDATE_FIELD = new List<String>{'change_status__c'};
    static List<String> POSITION_EMPLOYEE_INSERT_FIELD = new List<String>{'Position__c','Employee__c','Effective_End_Date__c','Assignment_Type__c', 'Reason_Code__c'};

}